/***************************************************************************************************/
/*script in Sql, generate by SdmCreateScript 2020(by Qihang Feng, QF255001@TERADATA.COM)     */
/*VERSION 01.10 revised on 2020-08-25                                                              */
/*Brilliance stems from wisdoms.                                                                   */
/*************Head Section**************************************************************************/
/*Script Use: Periodically load data to :t01_scrm_contact_update(SCRM联系方式变更)             */
/*Create Date:2024-04-18 17:27:03                                                                  */
/*SDM Developed By: dev                                                                            */
/*SDM Developed Date: 2024-04-18                                                                   */
/*SDM Checked By: dev                                                                              */
/*SDM Checked Date: 2024-04-18                                                                     */
/*Script Developed By: dev                                                                         */
/*Script Checked By: dev                                                                           */
/*Source table 1: :SADB.s98_s_scrm_contact                                                         */
/*Source table 2: p10_sa.s98_s_scrm_contact_lastupdated                                            */
/*Source table 3: :SADB.s98_s_customer_events_add_user                                             */
/*Job Type: Inbound transform (Tier 1 to Tier 2)                                                   */
/*Target Table:t01_scrm_contact_update                                                             */
/*ETL Job Name:t01_scrm_contact_update                                                             */
/*ETL Frequency:Daily                                                                              */
/*ETL Policy:F2                                                                                    */
/********************************************************************************************/
/*******Main Section**************************************************************************/
\set ON_ERROR_STOP on
\set AUTOCOMMIT on
\timing on



/*创建临时表加载当前数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_update_agi_CUR_I 
 ( LIKE :PDMDB.t01_scrm_contact_update)
ON COMMIT PRESERVE ROWS;



/*创建临时表加载不同数据                                                                           */
CREATE TEMPORARY TABLE t01_scrm_contact_update_agi_INS 
( LIKE :PDMDB.t01_scrm_contact_update)
ON COMMIT PRESERVE ROWS;

            
/*****************************************************************************************************/
/* GROUP 1:Source Table:s98_s_scrm_contact_lastupdated************************************************/
/*****************************************************************************************************/

INSERT INTO t01_scrm_contact_update_agi_CUR_I (
            scrm_leads_id                           /*线索ID*/
           ,city_name                               /*城市*/
           ,company_name                            /*公司*/
           ,email                                   /*邮箱*/
           ,mobile_number                           /*手机号码*/
           ,full_name                               /*姓名*/
           ,prov_name                               /*省份*/
           ,create_time                             /*创建时间*/
           ,wechat_id                               /*身份-企业微信外部联系人*/
           ,update_time                             /*更新时间*/
           ,etl_batch_no                            /*作业批次号*/
           ,etl_first_dt                            /*最初入库时间*/
           ,etl_job                                 /*作业名称*/
           ,etl_proc_dt                             /*本次入库时间*/
           ,etl_tx_dt                               /*作业运行时间*/
           ,src_sysname                             /*来源系统*/
           ,src_table                               /*来源表*/
        )
SELECT
         COALESCE(TRIM(CAST(p0.id AS VARCHAR(30))),'')             /*scrm_leads_id*/
        ,COALESCE(TRIM(CAST(p0.city AS VARCHAR(50))),'')           /*city_name*/
        ,COALESCE(TRIM(CAST(p0.company AS VARCHAR(50))),'')        /*company_name*/
        ,COALESCE(TRIM(CAST(p0.email AS VARCHAR(50))),'')          /*email*/
        ,COALESCE(TRIM(CAST(p0.mobile AS VARCHAR(20))),'')         /*mobile_number*/
        ,COALESCE(TRIM(CAST(p0.name AS VARCHAR(20))),'')           /*full_name*/
        ,COALESCE(TRIM(CAST(p0.province AS VARCHAR(50))),'')        /*prov_name*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.date_join AS VARCHAR(19)),'YYYY-MM-DDTHH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*create_time*/
        ,coalesce(p1.customer_id,'')                               /*wechat_id*/
        ,COALESCE(TO_TIMESTAMP(CAST(p0.last_updated AS VARCHAR(19)),'YYYY-MM-DDTHH24:mi:ss'),TO_TIMESTAMP(:NULLDATE,'YYYYMMDD'))        /*update_time*/
        ,0                                                         /*etl_batch_no*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_first_dt*/
        ,:ETLJOB                                                   /*etl_job*/
        ,current_timestamp(0)                                      /*etl_proc_dt*/
        ,TO_DATE(:TXDATE,'YYYYMMDD')                               /*etl_tx_dt*/
        ,Substr('s98_s_scrm_contact_lastupdated',1,3)              /*src_sysname*/
        ,'s98_s_scrm_contact_lastupdated'                          /*src_table*/
        
FROM p10_sa.s98_s_scrm_contact_lastupdated  p0
LEFT JOIN :SADB.s98_s_customer_events_add_user  p1
        ON p0.id=p1.customer_id
LEFT JOIN :SADB.s98_s_scrm_contact  p2
        ON p0.id=p2.id
where p2.id is null and p1.customer_id is not null and p0.mobile is not null and p0.email is not null

;



/*将不同数据插入到临时表                                                                           */
;INSERT INTO t01_scrm_contact_update_agi_INS (
         city_name                                                 /*城市*/
        ,company_name                                              /*公司*/
        ,email                                                     /*邮箱*/
        ,mobile_number                                             /*手机号码*/
        ,full_name                                                 /*姓名*/
        ,prov_name                                                 /*省份*/
        ,create_time                                               /*创建时间*/
        ,wechat_id                                                 /*身份-企业微信外部联系人*/
        ,scrm_leads_id                                             /*线索ID*/
        ,update_time                                               /*更新时间*/
        ,etl_batch_no                                              /*作业批次号*/
        ,etl_first_dt                                              /*最初入库时间*/
        ,etl_job                                                   /*作业名称*/
        ,etl_proc_dt                                               /*本次入库时间*/
        ,etl_tx_dt                                                 /*作业运行时间*/
        ,src_sysname                                               /*来源系统*/
        ,src_table                                                 /*来源表*/
        
)
    SELECT
         P1.city_name                                                 /*城市*/
        ,P1.company_name                                              /*公司*/
        ,P1.email                                                     /*邮箱*/
        ,P1.mobile_number                                             /*手机号码*/
        ,P1.full_name                                                 /*姓名*/
        ,P1.prov_name                                                 /*省份*/
        ,P1.create_time                                               /*创建时间*/
        ,P1.wechat_id                                                 /*身份-企业微信外部联系人*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.update_time                                               /*更新时间*/
        ,P1.etl_batch_no                                              /*作业批次号*/
        ,P1.etl_first_dt                                              /*最初入库时间*/
        ,P1.etl_job                                                   /*作业名称*/
        ,P1.etl_proc_dt                                               /*本次入库时间*/
        ,P1.etl_tx_dt                                                 /*作业运行时间*/
        ,P1.src_sysname                                               /*来源系统*/
        ,P1.src_table                                                 /*来源表*/
        
FROM t01_scrm_contact_update_agi_CUR_I P1
LEFT JOIN :PDMDB.t01_scrm_contact_update P2
ON    P1.city_name = P2.city_name
    AND P1.company_name = P2.company_name
    AND P1.email = P2.email
    AND P1.mobile_number = P2.mobile_number
    AND P1.full_name = P2.full_name
    AND P1.prov_name = P2.prov_name
    AND P1.create_time = P2.create_time
    AND P1.wechat_id = P2.wechat_id
    AND P1.scrm_leads_id = P2.scrm_leads_id
    AND P1.update_time = P2.update_time
    
WHERE  P2.city_name IS NULL
    OR P2.company_name IS NULL
    OR P2.email IS NULL
    OR P2.mobile_number IS NULL
    OR P2.full_name IS NULL
    OR P2.prov_name IS NULL
    OR P2.create_time IS NULL
    OR P2.wechat_id IS NULL
    OR P2.scrm_leads_id IS NULL
    OR P2.update_time IS NULL
    
; 
/*将新增数据插入到目标表                                                                           */
;INSERT INTO :PDMDB.t01_scrm_contact_update (
         city_name                                                 /*城市*/
        ,company_name                                              /*公司*/
        ,email                                                     /*邮箱*/
        ,mobile_number                                             /*手机号码*/
        ,full_name                                                 /*姓名*/
        ,prov_name                                                 /*省份*/
        ,create_time                                               /*创建时间*/
        ,wechat_id                                                 /*身份-企业微信外部联系人*/
        ,scrm_leads_id                                             /*线索ID*/
        ,update_time                                               /*更新时间*/
        ,etl_batch_no                                              /*作业批次号*/
        ,etl_first_dt                                              /*最初入库时间*/
        ,etl_job                                                   /*作业名称*/
        ,etl_proc_dt                                               /*本次入库时间*/
        ,etl_tx_dt                                                 /*作业运行时间*/
        ,src_sysname                                               /*来源系统*/
        ,src_table                                                 /*来源表*/
        
)
SELECT
         P1.city_name                                                 /*城市*/
        ,P1.company_name                                              /*公司*/
        ,P1.email                                                     /*邮箱*/
        ,P1.mobile_number                                             /*手机号码*/
        ,P1.full_name                                                 /*姓名*/
        ,P1.prov_name                                                 /*省份*/
        ,P1.create_time                                               /*创建时间*/
        ,P1.wechat_id                                                 /*身份-企业微信外部联系人*/
        ,P1.scrm_leads_id                                             /*线索ID*/
        ,P1.update_time                                               /*更新时间*/
        ,P1.etl_batch_no                                              /*作业批次号*/
        ,P1.etl_first_dt                                              /*最初入库时间*/
        ,P1.etl_job                                                   /*作业名称*/
        ,P1.etl_proc_dt                                               /*本次入库时间*/
        ,P1.etl_tx_dt                                                 /*作业运行时间*/
        ,P1.src_sysname                                               /*来源系统*/
        ,P1.src_table                                                 /*来源表*/
        
FROM t01_scrm_contact_update_agi_INS P1
ON CONFLICT ( scrm_leads_id,update_time)
DO UPDATE SET
     scrm_leads_id=excluded.scrm_leads_id
    ,update_time=excluded.update_time
    ,city_name=excluded.city_name
    ,company_name=excluded.company_name
    ,email=excluded.email
    ,mobile_number=excluded.mobile_number
    ,full_name=excluded.full_name
    ,prov_name=excluded.prov_name
    ,create_time=excluded.create_time
    ,wechat_id=excluded.wechat_id
    ,etl_batch_no=excluded.etl_batch_no
    ,etl_first_dt=excluded.etl_first_dt
    ,etl_job=excluded.etl_job
    ,etl_proc_dt=excluded.etl_proc_dt
    ,etl_tx_dt=excluded.etl_tx_dt
    ,src_sysname=excluded.src_sysname
    ,src_table=excluded.src_table
    

;
/*****程序结束退出                                               */
\q

